CREATE OR REPLACE VIEW V_KNJIZBE_BREME AS (
select MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP, SUM(K.BZNESEK) AS BREME 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
WHERE K.STRAN='B' AND K.TIPKNJ<>'Z' AND s.r_export_nr is null 
GROUP BY S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP
UNION ALL
select MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP, SUM(K.BZNESEK) AS BREME 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
join saldkont_zap sz on k.idmaster=sz.id_saldkont_zap
WHERE K.STRAN='B' AND K.TIPKNJ='Z' AND sz.r_export_nr is null 
GROUP BY S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP
)
;

CREATE OR REPLACE VIEW V_KNJIZBE_DOBRO AS (
select MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP, SUM(K.DZNESEK) AS DOBRO 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
WHERE K.STRAN='D' AND K.TIPKNJ<>'Z' AND s.r_export_nr is null 
GROUP BY S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP
UNION ALL
select MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP, SUM(K.DZNESEK) AS DOBRO 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
join saldkont_zap sz on k.idmaster=sz.id_saldkont_zap
WHERE K.STRAN='D' AND K.TIPKNJ='Z' AND sz.r_export_nr is null 
GROUP BY S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1194, SYSDATE, '5.5', 1114, 'Export records')
;