insert into nndrzave (sifra,opis,oznaka,slo,i,d,gb,cro,phone_code,interni_opis,sifra_eep)
values ('275','STATE OF PALESTINE','PS','PALESTINA','PALESTINA','PALESTINA','STATE OF PALESTINE','PALESTINA','+970','STATE OF PALESTINE','N');

CREATE TABLE WORKER_TASK_PERIOD (
ID_WORKER_TASK_PERIOD NUMBER NOT NULL,
DATE_FROM DATE,
DATE_TO DATE,
FREQUENCY NUMBER,
CONSTRAINT WORKER_TASK_PERIOD_PK PRIMARY KEY (ID_WORKER_TASK_PERIOD)
);

CREATE SEQUENCE WORKER_TASK_PERIOD_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE TABLE WORKER_TASK_PERIOD_DETAIL (
ID_WORKER_TASK_PERIOD_DETAIL NUMBER NOT NULL,
ID_WORKER_TASK_PERIOD NUMBER,
ID_WORKER_TASK NUMBER,
CONSTRAINT WORKER_TASK_PERIOD_DETAIL_PK PRIMARY KEY (ID_WORKER_TASK_PERIOD_DETAIL),
CONSTRAINT WTPD_ID_WORKER_TASK_PERIOD_FK FOREIGN KEY (ID_WORKER_TASK_PERIOD) REFERENCES WORKER_TASK_PERIOD(ID_WORKER_TASK_PERIOD),
CONSTRAINT MTPD_ID_WORKER_TASK_FK FOREIGN KEY (ID_WORKER_TASK) REFERENCES DELAVCI(ID_DELAVCI)
);

CREATE SEQUENCE WORKER_TASK_PERIOD_DETAIL_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE INDEX IX_WTPD_ID_WORKER_TASK_PERIOD ON WORKER_TASK_PERIOD_DETAIL (ID_WORKER_TASK_PERIOD);
CREATE INDEX IX_WTPD_ID_WORKER_TASK ON WORKER_TASK_PERIOD_DETAIL (ID_WORKER_TASK);

ALTER TABLE NUSER
ADD TIMESHEET_WORK_SOURCE VARCHAR2(3 CHAR);

ALTER TABLE NNDELAVC
ADD MANAGER VARCHAR2(20 CHAR);

UPDATE NNDELAVC N
SET N.MANAGER = (SELECT K.MANAGER FROM KUPCI K WHERE K.ID = N.ID_LASTNIKA)
WHERE N.MANAGER IS NULL AND N.ID_LASTNIKA IS NOT NULL;

DROP VIEW V_NNDELAVC;

CREATE OR REPLACE VIEW V_NNDELAVC AS (
  SELECT N.ID, N.SIFRA, N.OPIS, N.INTERNI_OPIS, N.PRICE, N.SELL_PRICE, N.ACT, N.NNLOCATION_ID, N.TYPE, N.NUSER, N.ID_LASTNIKA, N.MAX_WORK_HOURS, N.MANAGER,
  U.USER_ AS NUSER_USER, K.MANAGER AS KUPCI_MANAGER
  FROM NNDELAVC N
  LEFT OUTER JOIN NUSER U ON U.NUSER = N.NUSER
  LEFT OUTER JOIN KUPCI K ON K.ID = N.ID_LASTNIKA
);

DROP VIEW V_DELAVCI;

CREATE OR REPLACE VIEW V_DELAVCI AS (
	SELECT D.ID_DELAVCI, D.ID_STORITVE, D.SIFRA, D.DATUM, D.STEVILO_UR, D.HOURS_PLANNED, D.KOMENTAR, D.HOUR_FROM_PLANNED, D.ID_TIPSERVIS,
  D.STATUS_PLAN, D.STATUS_ACTUAL, D.DATE_APPROVED_PLAN, D.USER_APPROVED_PLAN, D.DATE_APPROVED_ACTUAL, D.USER_APPROVED_ACTUAL,
  TSP.DESCRIPTION AS STATUS_PLAN_DESCRIPTION, TSP.COLOR_PLAN AS STATUS_PLAN_COLOR, TSP.TEXT_COLOR_PLAN AS STATUS_PLAN_TEXT_COLOR, 
  TSA.DESCRIPTION AS STATUS_ACTUAL_DESCRIPTION, TSA.COLOR_ACTUAL AS STATUS_ACTUAL_COLOR, TSA.TEXT_COLOR_ACTUAL AS STATUS_ACTUAL_TEXT_COLOR, MS.ID_DN, MNS.OPIS AS NNSTOMAR_OPIS, 
  ND.NUSER AS NNDELAVC_NUSER, ND.MANAGER AS NNDELAVC_MANAGER, ND.OPIS AS NNDELAVC_OPIS, ND.INTERNI_OPIS AS NNDELAVC_INTERNI_OPIS, ND.PRICE AS NNDELAVC_PRICE, ND.TYPE AS NNDELAVC_TYPE, ND.NNLOCATION_ID AS NNDELAVC_NNLOCATION_ID, ND.ID AS NNDELAVC_ID, 
  KD.ID AS NNDELAVC_KUPCI_ID, KD.IME AS NNDELAVC_KUPCI_IME, KD.PRIIMEK AS NNDELAVC_KUPCI_PRIIMEK, KD.MANAGER AS NNDELAVC_KUPCI_MANAGER,
  TS.OPIS AS TIPSERVIS_OPIS, TS.INTERNAL AS TIPSERVIS_INTERNAL, MT.ID_MAINTENANCE_TASK AS MAINTENANCE_TASK_ID, MT.ID_CHECKLIST AS MAINTENANCE_TASK_ID_CHECKLIST,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') AS DATE_FROM_PLANNED,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') + D.HOURS_PLANNED/24 AS DATE_TO_PLANNED,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') AS DATE_FROM_ACTUAL,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') + D.STEVILO_UR/24 AS DATE_TO_ACTUAL
  FROM DELAVCI D
  LEFT OUTER JOIN M_STORITVE MS ON MS.ID_STORITVE = D.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR MNS ON MNS.SIFRA = MS.STORITEV
  LEFT OUTER JOIN NNDELAVC ND ON ND.SIFRA = D.SIFRA
  LEFT OUTER JOIN KUPCI KD ON KD.ID = ND.ID_LASTNIKA
  LEFT OUTER JOIN TIPSERVIS TS ON TS.SIFRA = D.ID_TIPSERVIS
  LEFT OUTER JOIN MAINTENANCE_TASK MT ON MT.ID_STORITVE = D.ID_STORITVE
  LEFT OUTER JOIN WORKER_TASK_STATUS TSP ON TSP.ID_WORKER_TASK_STATUS = D.STATUS_PLAN
  LEFT OUTER JOIN WORKER_TASK_STATUS TSA ON TSA.ID_WORKER_TASK_STATUS = D.STATUS_ACTUAL
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1536, SYSDATE, '5.5', 1456, 'Delavci')
;
