ALTER TABLE PREGLEDI
ADD DATUM_KREIRANJA DATE;

ALTER TABLE PREGLEDI_PRIVEZ
ADD DATUM_KREIRANJA DATE;

DROP VIEW V_PREGLEDI;

CREATE OR REPLACE VIEW V_PREGLEDI AS (
  SELECT P.ID_PREGLEDI, P.ID_LASTNIKA, P.ID_PLOVILA, P.NSTANJE, P.DATUM, P.CAS, P.KOMENTAR, P.KOMENTAR1, P.DATUM_KREIRANJA, P.USER_KREIRANJA, P.LASTNIK_OBVESCEN, P.N_PRIVEZA, P.OBJEKT, P.ID_STORITVE, P.STATUS,
  PL.IME AS PLOVILA_IME, NS.OPIS AS NSTANJE_OPIS, NS.INTERNI_OPIS AS NSTANJE_INTERNI_OPIS, NS.NSTANJE_TYPE AS NSTANJE_TYPE, NNP.NNLOCATION_ID, KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN P.ID_PRIVEZ IS NOT NULL THEN NP.OBJEKT ELSE P.OBJEKT END) AS NNPRIVEZ_OBJEKT, (CASE WHEN P.ID_PRIVEZ IS NOT NULL THEN NP.N_PRIVEZA ELSE P.N_PRIVEZA END) AS NNPRIVEZ_PRIVEZ,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) AS OWNER
	FROM PREGLEDI P
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KU ON KU.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NSTANJE NS ON NS.NSTANJE = P.NSTANJE
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = P.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNP ON NNP.SIFRA = NP.KATEGORIJA
);

DROP VIEW V_PREGLEDI_PRIVEZ;

CREATE OR REPLACE VIEW V_PREGLEDI_PRIVEZ AS (
  SELECT P.ID_PREGLEDI_PRIVEZ, P.ID_PRIVEZ, P.NSTANJE_PRIVEZ, P.DATUM, P.CAS, P.KOMENTAR, P.USER_KREIRANJA, P.DATUM_KREIRANJA,
  NP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NS.OPIS AS NSTANJE_PRIVEZ_OPIS, NS.INTERNI_OPIS AS NSTANJE_PRIVEZ_INTERNI_OPIS, NS.NSTANJE_TYPE AS NSTANJE_TYPE, NNP.NNLOCATION_ID
	FROM PREGLEDI_PRIVEZ P
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = P.ID_PRIVEZ
  LEFT OUTER JOIN NSTANJE_PRIVEZ NS ON NS.SIFRA = P.NSTANJE_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNP ON NNP.SIFRA = NP.KATEGORIJA
);

ALTER TABLE KUPCI_CREDIT_CARDS
ADD DATE_CREATED DATE;

ALTER TABLE KUPCI_CREDIT_CARDS
ADD DATE_CHANGED DATE;

ALTER TABLE KUPCI_CREDIT_CARDS
ADD USER_CREATED VARCHAR2(20 CHAR);

ALTER TABLE KUPCI_CREDIT_CARDS
ADD USER_CHANGED VARCHAR2(20 CHAR);


ALTER TABLE RACUNI_KUPCEV
ADD DATE_CREATED DATE;

ALTER TABLE RACUNI_KUPCEV
ADD DATE_CHANGED DATE;

ALTER TABLE RACUNI_KUPCEV
ADD USER_CREATED VARCHAR2(20 CHAR);

ALTER TABLE RACUNI_KUPCEV
ADD USER_CHANGED VARCHAR2(20 CHAR);

DROP VIEW V_KUPCI_CREDIT_CARDS;

CREATE OR REPLACE VIEW V_KUPCI_CREDIT_CARDS  AS (
SELECT KC.ID_KUPCI_CC, KC.ID_KUPCA, KC.ID_PLOVILA, KC.ID_CARDS, KC.CARD_ISSUER, KC.CARD_NUMBER, KC.CARD_NUMBER_ORG, KC.SEC_CODE, KC.CARD_OWNER, KC.CARD_EXPIRE, KC.PREFERRED, KC.ACTIVE, 
KC.TEMPORARY, KC.NNLOCATION_ID, KC.ID_CREDIT_CARD_TOKEN, KC.DATE_CREATED, KC.DATE_CHANGED, KC.USER_CREATED, KC.USER_CHANGED,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, P.IME AS PLOVILA_IME, N.OPIS AS CARDS_OPIS, N.INTERNI_OPIS AS CARDS_INTERNI_OPIS, CCT.TOKEN AS CREDIT_CARD_TOKEN, CI.OPIS AS CARD_ISSUER_OPIS,
NL.OPIS AS NNLOCATION_OPIS
FROM KUPCI_CREDIT_CARDS KC
LEFT OUTER JOIN KUPCI K ON K.ID = KC.ID_KUPCA
LEFT OUTER JOIN PLOVILA P ON P.ID = KC.ID_PLOVILA
LEFT OUTER JOIN NNCARDS N ON N.ID_CARDS = KC.ID_CARDS
LEFT OUTER JOIN CREDIT_CARD_TOKEN CCT ON CCT.ID = KC.ID_CREDIT_CARD_TOKEN
LEFT OUTER JOIN NNCARD_ISSUER CI ON CI.SIFRA =  KC.CARD_ISSUER
LEFT OUTER JOIN NNLOCATION NL ON NL.ID = KC.NNLOCATION_ID
);

DROP VIEW V_RACUNI_KUPCEV;

CREATE OR REPLACE VIEW V_RACUNI_KUPCEV
AS (
SELECT RK.ID_RACUNA, RK.ID_LASTNIKA, RK.ST_RACUNA, RK.OPIS, RK.BANKA, RK.PREFERRED, RK.DIRECT_DEBIT_AUTH, RK.DIRECT_DEBIT, RK.BANK_ABBREVIATION, RK.NNLOCATION_ID, RK.ID_CARDS, RK.SUBLEASE, RK.BIC,
RK.DATE_CREATED, RK.DATE_CHANGED, RK.USER_CREATED, RK.USER_CHANGED, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK
FROM RACUNI_KUPCEV RK
LEFT OUTER JOIN KUPCI K ON K.ID = RK.ID_LASTNIKA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1789, SYSDATE, '5.5', 1709, 'User date created')
;
