ALTER TABLE VRSTA_NAJAVE
ADD OWNER_CHECKIN VARCHAR2(1 CHAR);

ALTER TABLE VRSTA_NAJAVE
ADD OWNER_CHECKIN_COLOR VARCHAR2(20 CHAR);

ALTER TABLE NAJAVE
ADD OWNER_CHECKIN VARCHAR2(1 CHAR);

INSERT INTO ALARM_CHECK (SIFRA, OPIS, INTERNI_OPIS, ACTIVE, PRIORITY) VALUES 
('CRANE_PLAN_OWNER_CHECKIN_PORTAL', 'Portal crane plan owner checkin', 'Portal crane plan owner checkin', 'Y', 3);

INSERT INTO NNTOPIC(SIFRA, OPIS, INTERNI_OPIS) 
VALUES ('POC', 'Portal crane plan owner checkin', 'Portal crane plan owner checkin');

DROP VIEW V_NAJAVE;

CREATE OR REPLACE VIEW V_NAJAVE AS (
SELECT DISTINCT N.ID AS ID_NAJAVE, N.ID_DVIGALA, N.ID_LASTNIKA, N.ID_PLOVILA, N.ID_STORITVE, N.SIFRA_DVIGALA, N.SIFRA_STORITVE, N.VRSTA_NAJAVE, N.DATUM, N.DATUM_KONCA, N.URA_OD, N.URA_DO, N.DATUM_OD, N.DATUM_DO, N.CREATED_FROM_PORTAL,
N.LASTNIK_OBVESCEN, N.ID_PRIVEZ, NP.N_PRIVEZA, N.KOMENTAR, N.NAVODILO, N.ID_DN, N.STATUS, N.NNLOCATION_ID, N.MARINA, N.BERTH, N.QUANTITY, N.SIZE_OF_FILL, N.FILL_LOCATION, N.PONUDBA, N.ID_QUESTIONNAIRE_ANSWER_MASTER, N.ID_WAITLIST, N.OWNER_CHECKIN,
NS.OPIS AS STATUS_OPIS, NS.INTERNI_OPIS AS STATUS_INTERNI_OPIS, NS.COLOR AS STATUS_COLOR, NS.TEXT_COLOR AS STATUS_TEXT_COLOR,
VN.LIFT_SERVICE AS VRSTA_NAJAVE_LIFT_SERVICE, VN.LAUNCH_SERVICE AS VRSTA_NAJAVE_LAUNCH_SERVICE, VN.ID_QUESTIONNAIRE AS VRSTA_NAJAVE_ID_QUESTIONNAIRE, VN.COMPLETE_QUESTIONNAIRE_INSERT, VN.OWNER_CHECKIN_COLOR,
S.COMPLETE, M.OPIS AS STORITEV, M.CRANE_PLANNER_COLOR AS SERVICE_COLOR, P.IME AS IME_PLOVILA, P.REGISTRSKA_N, NT.OPIS AS TIP_PLOVILA, P.DOLZINA, P.TEZA AS TEZA_PLOVILA, P.DATUM_ZAVAROVANJE AS PLOVILA_DATUM_ZAVAROVANJE, 
P.N_ZAVAROVALNE_POLICE AS PLOVILA_N_ZAVAROVALNE_POLICE, BERTH_TEMP.N_PRIVEZA AS PLOVILA_TRENUTNA_N_PRIVEZA,
NVL(K.PRIIMEK, '') || ' ' || NVL(K.IME, '') AS LASTNIK, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME,
ND.OPIS AS NNDVIGAL_OPIS, ND.INTERNI_OPIS AS NNDVIGAL_INTERNI_OPIS, ND.NOSILNOST AS NNDVIGAL_NOSILNOST, ND.COLOR AS NNDVIGAL_COLOR, ND.NAME_BUILD_INSTRUCTION AS NNDVIGAL_NAME_BUILD_INSTR,
MD.DATUM_DN AS M_DE_NA_DATUM_DN, MD.TERMIN_DO AS M_DE_NA_TERMIN_DO, MD.STEVILKA AS M_DE_NA_STEVILKA, MD.KOMENTAR AS M_DE_NA_KOMENTAR, MD.ID_OWNER_SIGNATURE AS M_DE_NA_ID_OWNER_SIGNATURE,
(SELECT LISTAGG(KUP.IME,', ') WITHIN GROUP(ORDER BY KUP.IME ASC) BOAT_CONTACT_NAMES FROM KONT_OSB_PLOVILA KOP, KUPCI KUP WHERE KOP.ID_OSEBE = KUP.ID AND KOP.ID_PLOVILA = N.ID_PLOVILA) AS BOAT_CONTACT_NAMES,
CASE WHEN (SELECT COUNT(*) FROM NAJAVE_SERVICE NS WHERE NS.ID_NAJAVE = N.ID) > 0 THEN 'Y' ELSE 'N' END AS HAS_ADDITIONAL_SERVICES,
(SELECT LISTAGG(MS.OPIS,', ') WITHIN GROUP(ORDER BY MS.OPIS ASC) ADDITIONAL_SERVICES FROM NAJAVE_SERVICE NS, M_NNSTOMAR MS WHERE NS.SERVICE_CODE = MS.SIFRA AND NS.ID_NAJAVE = N.ID) AS ADDITIONAL_SERVICES,
N.USER_KREIRANJA, N.DATUM_KREIRANJA, N.USER_SPREMEMBE, N.DATUM_SPREMEMBE
FROM NAJAVE N
LEFT OUTER JOIN NNAJAVE_STATUS NS ON NS.SIFRA = N.STATUS
LEFT OUTER JOIN VRSTA_NAJAVE VN ON VN.SIFRA = N.VRSTA_NAJAVE
LEFT OUTER JOIN M_NNSTOMAR M ON N.SIFRA_STORITVE = M.SIFRA
LEFT OUTER JOIN PLOVILA P ON N.ID_PLOVILA = P.ID
LEFT OUTER JOIN NNTIP NT ON P.NTIP=NT.SIFRA
LEFT OUTER JOIN KUPCI K ON N.ID_LASTNIKA = K.ID
LEFT OUTER JOIN M_STORITVE S ON N.ID_STORITVE = S.ID_STORITVE
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = N.ID_PRIVEZ
LEFT OUTER JOIN NNDVIGAL ND ON ND.ID = N.ID_DVIGALA
LEFT OUTER JOIN M_DE_NA MD ON MD.ID_DN = N.ID_DN
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI ASC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NULL) PRIVEZI_TEMP ON (PRIVEZI_TEMP.ID_PLOVILA = P.ID AND PRIVEZI_TEMP.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_TEMP ON BERTH_TEMP.ID_PRIVEZ = PRIVEZI_TEMP.ID_PRIVEZ
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2186, SYSDATE, '5.5', 2106, 'Owner checkin')
;
