CREATE TYPE REZERVAC_DATE_ROW_TYPE AS OBJECT (
  DATUM  DATE
);;
;

CREATE TYPE REZERVAC_DATUMI_TABLE IS TABLE OF REZERVAC_DATE_ROW_TYPE;;
;

CREATE OR REPLACE FUNCTION GET_REZERVAC_DATUMI RETURN REZERVAC_DATUMI_TABLE IS
  REZERVAC_DATUMI_TBL  REZERVAC_DATUMI_TABLE := REZERVAC_DATUMI_TABLE();;
  START_DATE_NUM NUMBER;;
  END_DATE_NUM NUMBER;;
  START_DATE REZERVAC.DATUM_REZERVACIJE%TYPE;;
  END_DATE  REZERVAC.DATUM_DO%TYPE;;
BEGIN 
  SELECT MIN(DATUM_REZERVACIJE), MAX(DATUM_DO) INTO START_DATE, END_DATE FROM REZERVAC;;
  START_DATE_NUM := TO_NUMBER(TO_CHAR(START_DATE, 'j'));;
  END_DATE_NUM := TO_NUMBER(TO_CHAR(END_DATE, 'j'));;
  FOR CUR_DATE in START_DATE_NUM..END_DATE_NUM 
  LOOP
    REZERVAC_DATUMI_TBL.EXTEND;;
    REZERVAC_DATUMI_TBL(REZERVAC_DATUMI_TBL.LAST) := REZERVAC_DATE_ROW_TYPE(TO_DATE(CUR_DATE, 'j'));;
  END LOOP;;
  RETURN REZERVAC_DATUMI_TBL;;
END;;
;

CREATE OR REPLACE VIEW V_PRIVEZ_ZASEDENOST_DAN AS
SELECT CONCAT(CONCAT(DATUM, '-'), N.ID_PRIVEZ) AS V_PRIVEZ_ZASEDENOST_DAN_ID, DATUM AS DATUM, N.ID_PRIVEZ, N.LIMIT, (SELECT COUNT(RD.ID_REZERVAC_DETAIL) FROM REZERVAC_DETAIL RD WHERE RD.ID_PRIVEZ = N.ID_PRIVEZ 
AND RD.DATUM_OD <= DATUM AND RD.DATUM_DO > DATUM AND RD.STATUS_REZERVAC > 0 AND RD.STATUS_REZERVAC !=2) + 
(SELECT COUNT(DISTINCT(RD.ID_REZERVAC)) FROM REZERVAC_DETAIL RD WHERE RD.ID_PRIVEZ = N.ID_PRIVEZ AND RD.DATUM_DO <= DATUM AND RD.STATUS_REZERVAC = 1) AS ZASEDENO
FROM TABLE(CAST(GET_REZERVAC_DATUMI() AS REZERVAC_DATUMI_TABLE)), NNPRIVEZ N;

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(416, SYSDATE, '5.5', 336, 'Zasedenost privezov na dan');